function [FIG,FIG_ENG,battANALOG,ATTIVA] = report_WEL(rWEL,m,NodoWireExtensometerLink,toolrif,...
    unitrif,contunit,datarif,Font_caption,Font_tools,battANALOG,ATTIVA,siteID,DT,DT_ENG,...
    FIG,FIG_ENG,br,activeEN,status,conn,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'report_WEL function started';
fprintf(fileID,fmt,text);

import mlreportgen.dom.*
import mlreportgen.report.*

% Make sure DOM is compilable
makeDOMCompilable()

if status(m,1) == 1
    if ATTIVA == 1
        testo = Paragraph('GMUX non ancora installato o canale inattivo.');
        add(DT,testo);
        ATTIVA = 0;
        if activeEN == 1
            testo = Paragraph('GMUX not installed or inactive.');
            add(DT_ENG,testo);
        end
    end
elseif status(m,1) == 3
    if ATTIVA == 1
        testo = Paragraph(['Monitoraggio completato. Invitiamo a visitare la '...
            'piattaforma web per la visione dei dati storici.']);
        ATTIVA = 0;
        add(DT,testo);
        if activeEN == 1
            testo = Paragraph(['Monitoring completed. Please log into the web-based platform '...
                'to access the complete dataset.']);
            add(DT_ENG,testo);
        end
    end
else
    WE = Section();
    sezWEL = Heading3('Wire Extensometer Link');
    sezWEL.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
    WE.Title = sezWEL;
    if battANALOG == 0
        comando = ['select Date, Time, UnitName, ToolNameID, BatLevel, Temperature from RawDataView where Date >= ''' ...
            datarif ''' and UnitName = ''' char(unitrif) ''' and ToolNameID = '''...
            char(toolrif) ''' and NodeNum = 1 '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        BatTemp = curs.Data;
        [~,cc] = size(BatTemp);
        if cc ~= 1 %ci sono dati riferiti all'ultimo mese/periodo di interesse
            DataPlot = [BatTemp(:,1) BatTemp(:,2)];
            % sistemo date, batteria e temperatura
            [rD,~] = size(DataPlot);
            T = [cell2mat(DataPlot(:,1)) repmat(' ', [rD,1]) cell2mat(DataPlot(:,2))];
            Date = datenum(T);
            Batteria = cell2mat(BatTemp(:,5));
            Temperatura = cell2mat(BatTemp(:,6));
            
            % testo introduttivo
            testoB1 = Paragraph(['I valori di tensione di alimentazione del GMUX durante il periodo '...
                'di monitoraggio sono riportati di seguito. Il corretto funzionamento del sistema '...
                char(232) ' assicurato per una carica superiore a 12 V. L''ultimo dato disponibile ' char(232) ' pari '...
                'a ' num2str(Batteria(end,1)) ' V.']);
            testoB2 = Paragraph(['Il GMUX integra al proprio interno un termometro '...
                'per monitorate la temperatura di esercizio ed identificare eventuali '...
                'anomalie. I dati di temperatura registrati sono riportati di seguito.']);
            testoB1.HAlign = 'justify';
            testoB2.HAlign = 'justify';
            
            % grafico batteria
            figure(19)
            plot(Date,Batteria);
            hold on
            title('Batteria e Temperatura del GMUX');
            xlabel('Data [gg/mm/aaaa]');
            ylabel('Livello di Batteria [V]');
            ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
            
            yyaxis right
            GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
            ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
            ylabel(['Temperatura [' char(176) 'C]']);
            set(gca,'YColor','k');
            str(1,1) = cellstr('Batteria');
            str(2,1) = cellstr('Temperatura');
            legend(str,'Location','northwest');
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            xlim([Date(1)-1 Date(end)+1]);
            
            TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX.png'));
            saveas(GMUX,TempName);
            ChartGMUX = Image(TempName);
            ChartGMUX.Style = {Height('8cm'),HAlign('center')};
            if Batteria(end,1) >= 12.5
                TempName = char(strcat('B_13.jpg'));
            elseif Batteria(end,1) >= 12
                TempName = char(strcat('B_12.jpg'));
            elseif Batteria(end,1) >= 11.3
                TempName = char(strcat('B_115.jpg'));
            elseif Batteria(end,1) >= 10.5
                TempName = char(strcat('B_11.jpg'));
            else
                TempName = char(strcat('B_10.jpg'));
            end
            Batt = Image(TempName);
            Batt.Style = {Height('4cm'),HAlign('center')};
            
            lot = Table({ChartGMUX, Batt});
            lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
            lot.Style = {ResizeToFitContents(false),Width("100%")};
            grps(1) = TableColSpecGroup;
            grps(1).Span = 2;
            specs(1) = TableColSpec;
            specs(1).Span = 1;
            specs(1).Style = {Width("80%")};
            specs(2) = TableColSpec;
            specs(2).Span = 1;
            specs(2).Style = {Width("20%")};
            grps(1).ColSpecs = specs;
            lot.ColSpecGroups = grps;
            
            lot_cap = Paragraph(['Fig. ' num2str(FIG) ' - Livello di carica della batteria e temperatura del '...
                'GMUX durante il periodo di riferimento']);
            FIG = FIG+1;
            lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            sezBATT = Paragraph('GMUX - Batteria e Temperatura');
            sezBATT.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
            add(DT,sezBATT);
            add(DT,testoB1);
            add(DT,testoB2);
            add(DT,lot);
            add(DT,lot_cap);
            add(DT,br);
            close(figure(19));
            
            %--ENG---
            if activeEN == 1
                WE_ENG = Section();
                sezWEL_ENG = Heading3('Wire Extensometer Link');
                sezWEL_ENG.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                WE_ENG.Title = sezWEL_ENG;
                
                testoB1 = Paragraph(['The following chart reports the GMUX battery level trend recorded '...
                    'during the reference time period. '...
                    'The correct functioning of the data acquisition system is guaranteed for a '...
                    'minimum level of 12 V. The last available data is equal to ' num2str(Batteria(end,1)) ' V.']);
                testoB2 = Paragraph(['GMUX equips also a thermometer that allows the monitoring '...
                    'of the working temperature and the identification of eventual malfunctioning. The same '...
                    'chart displays also temperature data recorded by the multiplexer.']);
                testoB1.HAlign = 'justify';
                testoB2.HAlign = 'justify';
                
                % grafico batteria
                figure(19)
                plot(Date,Batteria);
                hold on
                title('GMUX battery level and temperature');
                xlabel('Date [dd/mm/yyyy]');
                ylabel('Battery Level [V]');
                ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
                
                yyaxis right
                GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
                ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
                ylabel(['Temperature [' char(176) 'C]']);
                set(gca,'YColor','k');
                str(1,1) = cellstr('Battery');
                str(2,1) = cellstr('Temperature');
                legend(str,'Location','northwest');
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                xlim([Date(1)-1 Date(end)+1]);
                
                TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX_ENG.png'));
                saveas(GMUX,TempName);
                ChartGMUX = Image(TempName);
                ChartGMUX.Style = {Height('8cm'),HAlign('center')};
                Batt = Image(TempNameB);
                Batt.Style = {Height('4cm'),HAlign('center')};
                
                lot = Table({ChartGMUX, Batt});
                lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
                lot.Style = {ResizeToFitContents(false),Width("100%")};
                grps(1) = TableColSpecGroup;
                grps(1).Span = 2;
                specs(1) = TableColSpec;
                specs(1).Span = 1;
                specs(1).Style = {Width("80%")};
                specs(2) = TableColSpec;
                specs(2).Span = 1;
                specs(2).Style = {Width("20%")};
                grps(1).ColSpecs = specs;
                lot.ColSpecGroups = grps;
                
                lot_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Battery level and temperature recorded '...
                    'by the GMUX during the reference time period']);
                FIG_ENG = FIG_ENG+1;
                lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                Batt_ENG = Section();
                sezBATT_ENG = Heading3('GMUX - Battery and temperature');
                sezBATT_ENG.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
                Batt_ENG.Title = sezBATT_ENG;
                add(DT_ENG,sezBATT_ENG);
                add(DT_ENG,testoB1);
                add(DT_ENG,testoB2);
                add(DT_ENG,lot);
                add(DT_ENG,lot_cap);
                add(DT_ENG,br);
                close(figure(19));
            end
            battANALOG = 1;
        end
    end
    add(DT,sezWEL);
    if activeEN == 1
        add(DT_ENG,sezWEL_ENG);
    end
    
    for w = 1:rWEL(m,1)
        NodeNum = num2str(NodoWireExtensometerLink(w,m));
        comando = ['select EventDate, EventTime, XShift, T_node from ElabDataView where EventDate >= ''' ...
            datarif ''' and  ToolNameID = ''' char(toolrif) ''' and UnitName = ''' char(unitrif) ...
            ''' and NodeNum = ''' NodeNum ''' '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        Dati = curs.Data;
        % Modifico il formato di data e ora
        [rD,rC] = size(Dati);
        if rC ~= 1
            T = [cell2mat(Dati(:,1)) repmat(' ', [rD,1]) cell2mat(Dati(:,2))];
            Date = datenum(T); % Data
            allungamento = cell2mat(Dati(:,3)); % allungamento filo
            var_X = allungamento - allungamento(1,:);
            TempWEL = cell2mat(Dati(:,4)); % temperatura
            
            % grafico allungamento NELL'ULTIMO MESE
            figure(10);
            if isnan(TempWEL(1)) == 0
                yyaxis left
            end
            wire = plot(Date,var_X);
            control = max(abs(var_X));
            if control < 1 % mm
                ylim([-1 1]);
            end
            hold on
            xlabel('Data [gg/mm/aaaa]');
            ylabel('Allungamento (+) / Accorciamento (-) [mm]');
            set(gca,'YColor','k');
            if isnan(TempWEL(1)) == 0
                yyaxis right
                plot(Date,TempWEL,':','LineWidth',1.1);
                ylabel(['Temperatura [' char(176) 'C]']);
                set(gca,'YColor','k');
                str(1,1) = cellstr('Variazione lunghezza filo');
                str(2,1) = cellstr('Temperatura');
                MX(1) = max(TempWEL(1:10));
                MX(2) = min(TempWEL(1:10));
                MAX = max(abs(MX));
                IN = find(abs(MX)==MAX);
                if IN == 1 % Legenda sotto
                    legend(str,'Location','southwest');
                else
                    legend(str,'Location','northwest');
                end
            end
            title(['Allungamento/accorciamento del filo del nodo numero ' NodeNum]);
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            
            TempName = char(strcat('Report',siteID,'-', char(toolrif),'-WireExt', NodeNum, '.png'));
            saveas(wire,TempName);
            ChartWEL = Image(TempName);
            ChartWEL.Style = {Height('7.3cm'),HAlign('center')};
            ChartWEL_cap = Paragraph(['Fig. ' num2str(FIG) ' - Variazione di lunghezza '...
                'registrata dall''estensimetro numero ' NodeNum ', '...
                'durante il periodo temporale di riferimento']);
            FIG = FIG+1;
            ChartWEL_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            
            testo = Paragraph(['I grafici seguenti rappresentano i dati relativi '...
                'alla variazione di lunghezza registrata dagli estensimetri a filo '...
                'collegati all''Analog Array. In particolare, valori positivi indicano '...
                'un allungamento, mentre numeri negativi rilevano un accorciamento.']);
            testo2 = Paragraph(['Durante il periodo temporale di riferimento, '...
                'il nodo numero ' NodeNum ' ha registrato valori massimi e minimi di lunghezza rispettivamente pari a '...
                num2str(round(max(var_X),2), '%0.2f') ' mm e ' num2str(round(min(var_X),2), '%0.2f')...
                ' mm, con una variazione di circa '...
                num2str(round(max(var_X),2)-round(min(var_X),2),'%0.2f') ' mm.' ]);
            testo.HAlign = 'justify';
            testo2.HAlign = 'justify';
            if w == 1
                add(DT,testo);
            end
            add(DT,testo2);
            add(DT,ChartWEL);
            add(DT,ChartWEL_cap);
            if w == rWEL(m,1)
                add(DT,br);
            end
            close(figure(10));
            
           %--ENG-- 
            
            if activeEN == 1
                % grafico allungamento NELL'ULTIMO MESE
                figure(20);
                if isnan(TempWEL(1)) == 0
                    yyaxis left
                end
                wire = plot(Date,var_X);
                control = max(abs(var_X));
                if control < 1 % mm
                    ylim([-1 1]);
                end
                hold on
                xlabel('Date [dd/mm/yyyy]');
                ylabel('Wire length increase (+) / decrease (-) [mm]');
                set(gca,'YColor','k');
                if isnan(TempWEL(1)) == 0
                    yyaxis right
                    plot(Date,TempWEL,':','LineWidth',1.1);
                    ylabel(['Temperature [' char(176) 'C]']);
                    set(gca,'YColor','k');
                    str(1,1) = cellstr('Wire length variation');
                    str(2,1) = cellstr('Temperature');
                    MX(1) = max(TempWEL(1:10));
                    MX(2) = min(TempWEL(1:10));
                    MAX = max(abs(MX));
                    IN = find(abs(MX)==MAX);
                    if IN == 1 % Legenda sotto
                        legend(str,'Location','southwest');
                    else
                        legend(str,'Location','northwest');
                    end
                end
                title(['Wire length increase/decrease, node ' NodeNum]);
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                
                TempName = char(strcat('Report',siteID,'-', char(toolrif),'-WireExt', NodeNum, '_ENG.png'));
                saveas(wire,TempName);
                ChartWEL_ENG = Image(TempName);
                ChartWEL_ENG.Style = {Height('7.3cm'),HAlign('center')};
                ChartWEL_ENG_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Wire length variation '...
                    'recorded by extensometer ' NodeNum ' '...
                    'during the reference time period']);
                FIG_ENG = FIG_ENG+1;
                ChartWEL_ENG_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                
                testo = Paragraph(['The following graphs display the wire length variation '...
                    'recorded by wire extensometer sensors integrated in the '...
                    'Analog Array. In particular, positive values represent a incresase of the '...
                    'wire length, while negative values indicate a shortening of the wire length.']);
                testo2 = Paragraph(['During the reference time period, '...
                    'node ' NodeNum ' recorded maximum and minimum values of wire length equal to '...
                    num2str(round(max(var_X),2), '%0.2f') ' mm and ' num2str(round(min(var_X),2), '%0.2f')...
                    ' mm respectively, corresponding to a length variation of '...
                    num2str(round(max(var_X),2)-round(min(var_X),2),'%0.2f') ' mm.' ]);
                testo.HAlign = 'justify';
                testo2.HAlign = 'justify';
                if w == 1
                    add(DT_ENG,testo);
                end
                add(DT_ENG,testo2);
                add(DT_ENG,ChartWEL_ENG);
                add(DT_ENG,ChartWEL_ENG_cap);
                if w == rWEL(m,1)
                    add(DT_ENG,br);
                end
                close(figure(20));
            end
            % pulisco variabili da riutilizzare per catena successiva
            clear allungamento;
        else
            if ATTIVA == 1
                testo = Paragraph('Non sono presenti dati relativi al periodo temporale considerato.');
                ATTIVA = 0;
                add(DT,testo);
                if activeEN == 1
                    testo = Paragraph('No data available for the reference time period.');
                    add(DT_ENG,testo);
                end
            end
        end
    end
end

text = 'report_WEL function executed correctly';
fprintf(fileID,fmt,text);
fclose(fileID);

end